
%==============================================================================
% BASIC PROLOG STUFF
%==============================================================================


:-compile(s).
:-compile(o).
:-compile(t).

k:- 
	compile(b),
	compile(s),
	compile(o),
	compile(t).


member22(X,[X|_]).
member22(X,[_|L]):- member22(X,L).

member212(X,[Y|_]):- X == Y, !.
member212(X,[_|L]):- member212(X,L),!.

concat312([],L,L):- !.
concat312([X|L1],L2,[X|L3]):- concat312(L1,L2,L3),!.

concat33([],L,L).
concat33([X|L1],L2,[X|L3]):- concat33(L1,L2,L3).

delete_all(_, [], []):- !.
delete_all(X, [Y|TL], L):- X == Y,!, delete_all(X, TL, L).
delete_all(X, [Y|TL], [Y|L]):- delete_all(X, TL, L).

delete32(X,[X|L],L).
delete32(X,[Y|L],[Y|L1]):- delete32(X,L,L1).

delete312(X, [Y|L], L):- X == Y, !.
delete312(X, [Y|L], [Y|L1]):- delete312(X, L, L1).

delete_repeats([], []):- !.
delete_repeats([X|R], R1):-
	member22(X1, R),
	X == X1, !,
	delete_repeats(R, R1).
delete_repeats([X|R], [X|R1]):-
	delete_repeats(R, R1), !.


lwrite( L ):- \+(\+( print_skolemized( L, 1, _ ) )), !.


print_skolemized( [], _, _ ):-!.
print_skolemized( [X|R], N1, N2 ):- 
	X == nl, 
	nl,
	print_skolemized( R, N1, N2 ), !.
print_skolemized( [T|R], N1, N2 ):-
	skolem( T, N1, N3 ), 
	write( T ),
	print_skolemized( R, N3, N2 ), !.


% skolemizes variables in any Prolog data structure, by
% x1,  x2, ... in order of appearance.    

skolem( Var, N, N1 ):-
                var( Var ),
		give_name(N,Var),  
		N1 is N + 1.
skolem( [], N, N ):-!.
skolem( [Term|RTerm], N, N2 ):-
                skolem( Term, N, N1 ), 
                skolem( RTerm, N1, N2 ), !.
skolem( Term, N, N1 ):- 
                Term =.. [_|LTerm], 
                skolem( LTerm, N, N1 ).


give_name(1,'X'):-!.
give_name(2,'Y'):-!.
give_name(3,'Z'):-!.
give_name(N,Var):-
		N>3,
		ascii( N, [], L ),
		name( Var, [88|L] ), !.


ascii( 0, L, L ):-!.
ascii( N, L1, L2 ):-
	K is N mod 10,
	A is K+48,
	N1 is N // 10,
	ascii( N1, [A|L1], L2 ), !.

% eof ----------------------------------------------------------------------
